#ifndef STATIC_CONTAINER_LIST_NODE_POOL_H

#define STATIC_CONTAINER_LIST_NODE_POOL_H

/*
zlib/libpng license
-------------------

Copyright (C) 2004 &o

This software is provided 'as-is', without any express or implied warranty. In n
o event will the authors be held liable for any damages arising from the use of 
this software.

Permission is granted to anyone to use this software for any purpose, including 
commercial applications, and to alter it and redistribute it freely, subject to 
the following restrictions:

The origin of this software must not be misrepresented; you must not claim that 
you wrote the original software. If you use this software in a product, an ackno
wledgment in the product documentation would be appreciated but is not required.

Altered source versions must be plainly marked as such, and must not be misrepre
sented as being the original software.
This notice may not be removed or altered from any source distribution.

project site : https://sourceforge.jp/projects/gslib/
my site : http://www.game-syokunin.com/
--------------------------------------------------------------------------------

@Iɂ́AĽ̂قLȂ̂ŁA茵ɂ͓{Qlɂ
ĂB{́Ahttp://opensource.jp/licenses/zlib-license.html 璸
Ă܂B

zlib/libpngCZX ( { )

Copyright (C) 2004 &o

{\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂
Ȃ񋟂܂B{\tgEFA̎gpɂĐ邢Ȃ鑹QɂĂA
͈؂̐ӔC𕉂Ȃ̂Ƃ܂B ȉ̐ɏ]ApAvP[V
܂߂āA{\tgEFACӂ̖ړIɎgpARɉςčĔЕz邱Ƃ
Ă̐lɋ܂B

{\tgEFȀoɂċU̕\Ă͂Ȃ܂BȂIWĩ\
tgEFA쐬Ǝ咣Ă͂Ȃ܂BȂ{\tgEFA𐻕iŎgp
ꍇAi̕ɎӎĂ΍KłAK{ł͂܂B
\[XύXꍇ́ÂƂ𖾎Ȃ΂Ȃ܂BIWĩ\tgE
FAłƂU̕\Ă͂Ȃ܂B
\[X̔ЕzA̕\폜A\̓eύX肵Ă͂Ȃ܂
B 

project site : https://sourceforge.jp/projects/gslib/
my site : http://www.game-syokunin.com/
*/

#include <boost/noncopyable.hpp>
#include <gslib/static_container/list_node.h>
#include <gslib/static_container/STATIC_CONTAINER_MEMBERTYPEDEF.h>
#include <gslib/numeric.h>

namespace gslib {
	namespace static_container {
		///	ListNode pv[ۃNX
		/**
		 *	TuNX̓RXgN^ init() Ă΂Ȃ΂ȂȂB
		 */
		template < typename Value >
		class abstruct_list_node_pool : boost::noncopyable {
		public:
			typedef list_link			link;
			typedef list_node< Value >	node;
			STATIC_CONTAINER_MEMBERTYPEDEF( Value )
		private:
			link	free_;
			
		protected:
			abstruct_list_node_pool() {
			}
			virtual node*	getTop() = 0;

			void	init() {
				//	ׂĂ̗vf free_ ɒǉ
				node* top = getTop();
				free_.next = top;
				free_.prev = top + size() - 1;
				top->prev = &free_;
				free_.prev->next = &free_;
				for ( size_type i = 1; i < size(); ++i ) {
					top[ i - 1 ].next = &top[ i ];
					top[ i ].prev = &top[ i - 1 ];
				}
			}
		public:
			virtual size_type size() const = 0;

			///	̈̑ݗ^̂݁Bvalue ̃RXgN^ĂяóA[U[̐ӔCB
			node* allocate() {
				if ( free_.next != &free_ ) {
					node* result = static_cast< node* >( free_.next );
					result->isolate();
					return result;
				} else {
					return 0;
				}
			}

			///	[ first, last )  free_ ̏I[ɐڑ
			/**
			 *	fXgN^Ăяo͍sȂ
			 */
			void	deallocate( link* first, link* last ) {
				if ( first == last ) {
					return;
				}
				
				//	ufirst ̒OvƁulastvڑ
				first->prev->next = last;
				link* lastPrev = last->prev;
				last->prev = first->prev;

				//	[ first, lastPrev ]  free_ ̏I[ɐڑ
				first->prev = free_.prev;
				free_.prev->next = first;
				free_.prev = lastPrev;
				lastPrev->next = &free_;
			}

			///	n  free_ ̏I[ɐڑ
			/**
			 *	fXgN^Ăяo͍sȂ
			 */
			void	deallocate( link* n ) {
				deallocate( n, n->next );
			}

			///	^?
			/**
			 *	@retval	true	ȏ}s\
			 *	@retval	false	}\
			 */
			bool full() const {
				return free_.next == &free_;
			}

			///	󂫃m[h擾
			size_type rest() const {
				link* n = free_.next;
				size_type result = 0;
				while ( &free_ != n ) {
					n = n->next;
					++result;
				}
				return result;
			}
		};

		///	ListNode pv[
		template < typename Value, uint_fast_t Size >
		class list_node_pool : public abstruct_list_node_pool< Value > {
			uintptr_t		buffer_[ Size * sizeof( node ) / sizeof( uintptr_t ) ];
			virtual node*	getTop() {
				return reinterpret_cast< node* >( buffer_ );
			}
		public:
			list_node_pool() {
				init();
			}

			virtual size_type size() const {
				return Size;
			}
		};
	}
}

#endif