#ifndef STATIC_CONTAINER_STRING_H

#define STATIC_CONTAINER_STRING_H

/*
zlib/libpng license
-------------------

Copyright (C) 2004 &o

This software is provided 'as-is', without any express or implied warranty. In n
o event will the authors be held liable for any damages arising from the use of 
this software.

Permission is granted to anyone to use this software for any purpose, including 
commercial applications, and to alter it and redistribute it freely, subject to 
the following restrictions:

The origin of this software must not be misrepresented; you must not claim that 
you wrote the original software. If you use this software in a product, an ackno
wledgment in the product documentation would be appreciated but is not required.

Altered source versions must be plainly marked as such, and must not be misrepre
sented as being the original software.
This notice may not be removed or altered from any source distribution.

project site : https://sourceforge.jp/projects/gslib/
my site : http://www.game-syokunin.com/
--------------------------------------------------------------------------------

@Iɂ́AĽ̂قLȂ̂ŁA茵ɂ͓{Qlɂ
ĂB{́Ahttp://opensource.jp/licenses/zlib-license.html 璸
Ă܂B

zlib/libpngCZX ( { )

Copyright (C) 2004 &o

{\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂
Ȃ񋟂܂B{\tgEFA̎gpɂĐ邢Ȃ鑹QɂĂA
͈؂̐ӔC𕉂Ȃ̂Ƃ܂B ȉ̐ɏ]ApAvP[V
܂߂āA{\tgEFACӂ̖ړIɎgpARɉςčĔЕz邱Ƃ
Ă̐lɋ܂B

{\tgEFȀoɂċU̕\Ă͂Ȃ܂BȂIWĩ\
tgEFA쐬Ǝ咣Ă͂Ȃ܂BȂ{\tgEFA𐻕iŎgp
ꍇAi̕ɎӎĂ΍KłAK{ł͂܂B
\[XύXꍇ́ÂƂ𖾎Ȃ΂Ȃ܂BIWĩ\tgE
FAłƂU̕\Ă͂Ȃ܂B
\[X̔ЕzA̕\폜A\̓eύX肵Ă͂Ȃ܂
B 

project site : https://sourceforge.jp/projects/gslib/
my site : http://www.game-syokunin.com/
*/

#include <iosfwd>
#include <boost/assert.hpp>
#include <gslib/static_container/STATIC_CONTAINER_MEMBERTYPEDEF.h>
#include <gslib/numeric.h>
#include <algorithm>

namespace gslib {
	namespace static_container {
		///	ÓI
		/**
		 *	̔zȂ̂ŁAoCit@Cւ̖ߍ݂ȒPB
		 *	^ꂽ񂪍ő啶𒴂ꍇANvB
		 *
		 *	Iɂ́ACh[ MaxStrLen + 1 ] ݂̂𗘗pB
		 */
		template< size_t MaxStrLen, typename Ch = char, typename ChTraits = std::char_traits< Ch > >
		class string {
		public:
			STATIC_CONTAINER_MEMBERTYPEDEF( Ch )
			typedef Ch				char_type;
			typedef ChTraits		traits_type;
			typedef pointer			iterator;
			typedef const_pointer	const_iterator;
		private:
			Ch	buffer_[ MaxStrLen + 1 ];
		public:
			///	őTCY
			BOOST_STATIC_CONSTANT( size_type, npos = -1 );
			BOOST_STATIC_CONSTANT( size_type, const_max = MaxStrLen );

			///	őTCY擾
			static size_type max_size() { return const_max; }

			///	eʎ擾
			static size_type capaciry() { return const_max; }
		
			/// TCY擾
			size_type size() const { return traits_type::length( buffer_ ); }

			/// TCY擾
			size_type length() const { return size(); }

			iterator begin() { return buffer_; }
			const_iterator begin() const { return buffer_; }
			iterator end() { return begin() + size(); }
			const_iterator end() const { return begin() + size(); }

			char_type& operator [] ( size_type i ) {
				PYD_ASSERT( i < size() );
				return *( begin() + i );
			}
			const char_type& operator [] ( size_type i ) const {
				PYD_ASSERT( i < size() );
				return *( begin() + i );
			}
			bool empty() const {
				return 0 == size();
			}
			reference at( size_type i ) { return operator [] ( i ); }
			char_type at( size_type i ) const { return operator [] ( i ); }

			reference front() { return *begin(); }
			char_type front() const { return *begin(); }
			reference back() { return *( end() - 1 ); }
			char_type back() const { return *( end() - 1 ); }
		
			///	ꕶǉ
			void push_back( char_type ch ) {
				//BOOST_ASSERT;
				if ( size() < MaxStrLen ) {
					iterator last = end();
					*last = ch;
					++last;
					*last = char_type();
				}
			}

			///	ꕶǉ
			void append( char_type ch ) {
				push_back( ch );
			}

			///	𖖔ɒǉ
			void append( const char* str ) {
				if ( 0 == str ) {
					return;
				}
				if ( size() + traits_type::length( str ) <= max_size() ) {
					traits_type::copy( end(), str, traits_type::length( str ) + 1 );
				} else {
					traits_type::copy( end(), str, max_size() );
					buffer_[ MaxStrLen ] = char_type();
				}
			}

			///	𖖔ɒǉ
			template < size_type OtherMaxStrLen >
			void append( const string< OtherMaxStrLen, Ch, ChTraits >& other ) {
				append( other.c_str() );
			}

			///	ꕶ폜
			void pop_back() {
				BOOST_ASSERT( false == empty() );
				iterator last = end();
				--last;
				*last = char_type();
			}

			/// ftHgRXgN^
			string() {
				clear();
			}
			
			/// Rs[RXgN^
			template < size_type OtherMaxStrLen >
			string( const string< OtherMaxStrLen, Ch, ChTraits >& other ) {
				if ( buffer_ != other.begin() ) {
					size_type otherLen = other.size();
					if ( otherLen <= max_size() ) {
						traits_type::copy( buffer_, other.begin(), otherLen + 1 );
					} else {
						traits_type::copy( buffer_, other.begin(), max_size() + 1 );
					}
				}
			}

			string( const char_type* s ) {
				if ( s != buffer_ ) {
					size_type otherLen = traits_type::length( s );
					if ( otherLen <= max_size() ) {
						traits_type::copy( buffer_, s, otherLen + 1 );
					} else {
						traits_type::copy( buffer_, s, max_size() + 1 );
					}
				}
			}

			// fXgN^
			~string() {
			}

			/// Zq
			string& operator = ( const string& other )	{
				return operator = ( other.c_str() );
			}
			string& operator = ( const char_type* s ) {
				if ( s != buffer_ ) {
					clear();
					append( s );
				}
				return *this;
			}
			
			/// ANZX
			pointer data() { return begin(); }
			const_pointer data() const { return begin(); }
			const_pointer c_str() const { return begin(); }

			///	append() Ɠł
			string operator += ( const char* other ) {
				append( other );
				return *this;
			}

			///	append() Ɠł
			template < size_type OtherMaxStrLen >
			string operator += ( const string< OtherMaxStrLen, Ch, ChTraits >& other ) {
				append( other );
				return *this;
			}
			
			///	󕶎
			void clear() {
				buffer_[ 0 ] = char_type();
			}

			///	H
			template < size_type OtherMaxStrLen >
			friend bool operator == ( const string& a, const string< OtherMaxStrLen, Ch, ChTraits >& b ) {
				return operator == ( a, b.c_str() );
			}

			///	H
			friend bool operator == ( const string& a, const char* b ) {
				size_type size = a.size();
				return char_type() == b[ size ] &&
					std::equal( a.begin(), a.begin() + size, b, traits_type::eq );
			}

			///	H
			friend bool operator == ( const char* a, const string& b ) {
				return operator == ( b, a );
			}
			
			///	قȂH
			template < size_type OtherMaxStrLen >
			friend bool operator != ( const string& a, const string< OtherMaxStrLen, Ch, ChTraits >& b ) {
				return !operator == ( a, b );
			}

			///	قȂH
			friend bool operator != ( const string& a, const char* b ) {
				return !operator == ( a, b );
			}

			///	قȂH
			friend bool operator != ( const char* a, const string& b ) {
				return !operator == ( a, b );
			}

			///	r
			template < size_type OtherMaxStrLen >
			friend bool operator < ( const string& a, const string< OtherMaxStrLen, Ch, ChTraits >& b ) {
				return operator < ( a, b.c_str() );
			}

			///	r
			friend bool operator < ( const string& a, const char* b ) {
				return std::lexicographical_compare(
					a.begin(), a.end(),
					b, b + traits_type::length( b ),
					traits_type::eq_int_type );
			}

			///	r
			friend bool operator < ( const char* a, const string& b ) {
				return operator < ( b, a );
			}
		};
	}
}

#endif