#include <gslib/test/assert_new.h>
#define BOOST_AUTO_TEST_MAIN
#include <boost/test/auto_unit_test.hpp>
#include <gslib/static_container/list.h>
#include "basic_sequence.h"
#include <iterator>
#include <boost/iterator/counting_iterator.hpp>

using namespace gslib;
using namespace static_container;

struct listgen {
	template < typename Value, size_t Size >
	struct gen {
		typedef list< Value, Size >	type;
	};
};

BOOST_AUTO_UNIT_TEST( test_list_basic ) {
	test::assert_new::begin(); // new Ăяoɓ{苶I
	basic_sequence< listgen >();
	test::assert_new::end();
}

BOOST_AUTO_UNIT_TEST( test_lodge_list ) {
	test::assert_new::begin(); // new Ăяoɓ{苶I
	list_node_pool< int, 10 >	pool;
	lodge_list< int >	list0( pool );
	lodge_list< int >	list1( pool );
	lodge_list< int >	list2( pool );
	
	BOOST_REQUIRE( 10 == pool.rest() );
	BOOST_REQUIRE( list0.empty() );
	list0.push_back( 100 );
	BOOST_REQUIRE( 1 == list0.size() );
	BOOST_REQUIRE( 9 == pool.rest() );
	BOOST_REQUIRE( 100 == list0.front() );
	
	list1.push_back( 10 );
	list2.push_back( 5 );
	list0.push_back( 9 );
	BOOST_REQUIRE( 6 == pool.rest() );
	list1.pop_back();
	BOOST_REQUIRE( 7 == pool.rest() );
	
	//	NẤAlist0 ̂
	list0.clear();
	BOOST_REQUIRE( list0.empty() );
	BOOST_REQUIRE( 9 == pool.rest() );	// ̃XgLm[h͂܂ԋpĂȂ
	
	std::copy( boost::counting_iterator< int >( 0 ), boost::counting_iterator< int >( pool.rest() ), std::back_inserter( list1 ) );
	BOOST_REQUIRE( 0 == pool.rest() );
	
	BOOST_REQUIRE( list1.end() != std::find( list1.begin(), list1.end(), 5 ) );
	lodge_list< int >::iterator it = list1.begin();
	std::advance( it, 5 );
	list1.erase( it );
	BOOST_REQUIRE( list1.end() == std::find( list1.begin(), list1.end(), 5 ) );
	test::assert_new::end();
}
